<template>
  <div id="deviceList">
    <el-row class="right">
      <!-- <span style="float:left;">当前选择的部件类型:{{page.total || '--'}}</span> -->
      <el-select v-model="showType" @change="initTable" style="width:125px;margin-right:10px;vertical-align:bottom;">
        <el-option v-for="item in showTypes" :key="item.value" :label="item.label" :value="item.value"></el-option>
      </el-select>
      <span>增加</span>
      <el-input v-model="addNum" style="width:50px;" size="small"></el-input>
      <span>个租户</span>
      <el-button @click="handleAddTableRow">增加</el-button>
    </el-row>
    <div class="tableBox">
      <div class="center middle_sty" style="flex:2;" v-show="tableData && !tableData.length">
        <p>
          <i class="icon-wushuju iconfont"></i>
          暂无数据
        </p>
      </div>
      <div class="tableLeft" v-show="tableData && tableData.length">
        <handson-table ref="table"></handson-table>
      </div>
    </div>
    <el-row class="center create_button">
      <el-button type="primary" size="medium" @click="handleCreateTableData">创建租户</el-button>
    </el-row>
  </div>
</template>
<script>
import tools from "@/utils/scan/tools"
import handsonUtils from "@/utils/hasontableUtils"
import showTools from "@/utils/handsontable/notShow"
import text from "@/utils/handsontable/mainText"
import session from "@/framework/utils/storage"

import handsonTable from "@/components/common/handsontable"
import { getDataDictionary, getRentTableHeader, createRentTableData } from "@/api/scan/request"
import { mapGetters, mapActions } from "vuex";
export default {
  components: {
    handsonTable
  },
  data() {
    return {
      addNum: 1,
      isTableRightShow: false,
      relationids: "",
      onlyRead: false,
      showTypes: [
        // { value: "partInfo", label: '隐藏信息点' }, 
        { value: "all", label: '全部' }, 
        { value: "Visible", label: '只看采集信息' }
      ],
      showType: this.$route.query.showType,
      tableHeader: [],
      tableData: session.get("rentAddData")? session.get("rentAddData").length? session.get("rentAddData"): [{}]: [{}],
      copyTableData: []
    };
  },
  computed: {
    ...mapGetters("layout", [ "projectId", "secret", "userId" ])
  },
  created() {
    this.getTableHeader()
  },
  // watch: {

  // },
  methods: {
    // 获取表头数据(初始化表格)
    async getTableHeader() {
      let param = {
        data: {
          Orders: "sort asc, InfoPointName desc",
          PageNumber: 1,
          PageSize: 1000,
        },
        type: 'Tenant'
      }
      await getDataDictionary(param, res => {
        this.tableHeader = res.Content
        this.initTable()
      })
    },
    // 创建租户数据
    async handleCreateTableData() {
      let params = {}
      let flag = 0;//1.存在未填写租户本地名称的数据
      let newData = this.tableData.filter((item) => {
        let keys = Object.keys(item)
        keys.map((key) => { //将值为空字符串的属性删除
          if(item[key] == "") {
            delete item[key]
          }
        })
        if (!item.TenantLocalName) {
          flag = 1
        }
        if(keys.length && Object.keys(item).length) {
          return item
        }
      })
      if(!newData.length) {
        this.$message("创建信息为空,请录入信息后再创建!")
        return
      } else if (flag == 1) {
        this.$message("存在未填写租户本地名称的数据,请填写信息后再创建!")
        return
      }
      params.Content = newData
      await createRentTableData(params, (res) => {
        this.$message.success("添加成功!")
        session.remove("rentAddData")
        this.$router.push({ name: 'rentlist'})
      })
    },
    // 删除表格行
    handleDeleteTableRow() {
      this.$message.success("删除成功")
      this.formaTableData()
    },
    // 添加行
    handleAddTableRow() {
      let addRowLength = this.addNum
      for(let i = 0; i < addRowLength; i++){
        this.tableData.push({})
      }
      this.initTable()
      this.formaTableData()
    },
    //修改
    handleUpdataTable(changeData, source) {
      this.formaTableData()
    },
    //保存去掉空字段的新增数据
    formaTableData() {
      let newData = this.tableData.filter((item) => {
        let keys = Object.keys(item)
        keys.map((key) => { //将值为空字符串的属性删除
          if(item[key] == "") {
            delete item[key]
          }
        })
        if(keys.length && Object.keys(item).length) {
          return item
        }
      })
      session.set("rentAddData", newData)
    },
    //关闭右侧关联元空间输入按钮
    handleCloseRight() {
      this.isTableRightShow = false
    },
    formatHeaderData(list) {//格式化表头显示的数据
      let arr = tools.copyArr(list)
      let data = showTools.headerTextFilter(arr, "tenant", this.onlyRead, this.showType)
      // data.unshift("关联的元空间");
      return data;
    },
    formatHeaderType(list) {//格式化表头头映射的数据
      let arr = tools.copyArr(list);
      let data = showTools.headerTypeFilter(arr, "tenant", this.onlyRead, this.showType)
      // data.unshift({
      //   data: "SpaceCount",
      //   readOnly: this.onlyRead
      // })
      return data;
    },
    initTable() {//实例化表格
      let settings = {
        data: this.tableData,
        colHeaders: this.formatHeaderData(this.tableHeader),
        columns: this.formatHeaderType(this.tableHeader),
        rowHeights: 30,
        maxRows: this.tableData.length,
        contextMenu: this.onlyRead ? false :{
          items: {
            remove_row: {
              name: "删除租户"
            }
          }
        },
        // 事件
        afterChange: this.handleUpdataTable, //修改后
        afterFilter: this.trimmedRows, //排序前
        afterRemoveRow: this.handleDeleteTableRow, //右键删除
        afterOnCellMouseDown: this.handleTdClick //鼠标点击
      };
      this.$nextTick(() => {
        console.log(this.$refs.table);
        this.tableExample = this.$refs.table.init(settings);
      });
    },
    //获取到了正确的信息
    getInfors(infos, row) {
      //其他的开始判断
      let val = this.tableExample.colToProp(row.col);
      this.row = row.row //要操作的列号
      this.messKey = val //要操作的列类型
      //点击关联的元空间
      // if (val === "SpaceCount") {
      //   this.isTableRightShow = true;
      // }
    },
    //表格点击事件
    handleTdClick(el, rowArr) {
      //点击的是表头
      if (rowArr.row < 0) {
        return;
      }
      //被筛选过后的数组
      let trimmedArr = this.trimmedRows();
      //是否启用了排序
      let isSort = this.tableExample.getPlugin("columnSorting").isSorted();
      if (trimmedArr.length && isSort) {
        let sortArr = this.myHotArr.getPlugin("columnSorting").rowsMapper
          .__arrayMap;
        let infos = this.tableData[trimmedArr[sortArr[rowArr.row]]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (isSort) {
        //排序后的数组
        let sortArr = this.tableExample.getPlugin("columnSorting").rowsMapper.__arrayMap;
        let infos = this.tableData[sortArr[rowArr.row]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (trimmedArr.length) {
        let infos = this.tableData[trimmedArr[rowArr.row]];
        this.getInfors(infos, { row: trimmedArr[rowArr.row], col: rowArr.col });
      } else {
        let infos = this.tableData[rowArr.row];
        this.getInfors(infos, rowArr);
      }
    },
    //获取被筛选掉的行号
    trimmedRows() {
      // var plugin = hot.getPlugin('trimRows').trimmedRows;//获取被筛选掉的行号
      var plugin = this.tableExample.getPlugin("trimRows").trimmedRows;
      let dataLength = this.tableData.length;
      let dataArr = new Array();
      for (let i = 0; i < dataLength; i++) {
        dataArr.push(i);
      }
      if (plugin.length <= 0) {
        dataArr = undefined;
      } else {
        dataArr = this.array_diff(dataArr, plugin);
      }
      return dataArr || [];
      // var DataArray = new Array();

      // for (var i = 0; i < plugin.length; i++) {
      //     // 通过行号获取数据
      //     DataArray.push(this.tableExample.getSourceDataAtRow(plugin[i]));
      // }
    },
    //去除数组中相同的元素
    array_diff(a, b) {
      for (var i = 0; i < b.length; i++) {
        for (var j = 0; j < a.length; j++) {
          if (a[j] == b[i]) {
            a.splice(j, 1);
            j = j - 1;
          }
        }
      }
      return a;
    }
  }
};
</script>
<style lang="less" scoped>
#deviceList {
  overflow: hidden;
  height: 100%;
  background-color: #fff;
  padding: 10px;
  position: relative;
  .right {
    background: #fff;
  }
  .search-header {
    overflow: hidden;
    padding:0 10px 10px 10px;
    border-bottom: 1px solid #bcbcbc;
  }
  .tableBox {
    display: flex;
    height: calc(100% - 100px);
    margin-top: 10px;
    .tableLeft {
      flex: 2;
    }
    .tableRight {
      flex: 1;
      // display: none;
      border-left: 1px solid #dadada;
      padding: 5px 15px;
      margin-right: 5px;
      box-shadow: 0px 1px 5px 0px rgba(59, 66, 84, 0.15);
      .table_right_box::after{
        display: block;
        content: "";
        clear: both;
      }
      .close_right {
        float: right;
        cursor: pointer;
      }
    }
  }
  .create_button{
    margin-top: 10px;
  }
}
</style>
